/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.Fighter
 *  fire.pb.buff.BuffMonsterImpl
 *  fire.pb.buff.Module
 *  fire.pb.buff.continual.ConstantlyBuff
 *  fire.pb.school.SchoolConst
 *  fire.pb.skill.fight.FightSkillConfig
 *  fire.pb.skill.liveskill.LiveSkillManager
 *  fire.script.AbstractJSEngine
 *  fire.script.FightJSEngine
 *  fire.script.JavaScript
 *  org.apache.log4j.Logger
 *  xbean.BattleInfo
 *  xbean.Monster
 *  xbean.MonsterSkill
 *  xbean.PracticeSkill
 */
package fire.pb.skill;

import fire.pb.battle.Fighter;
import fire.pb.buff.BuffMonsterImpl;
import fire.pb.buff.continual.ConstantlyBuff;
import fire.pb.school.SchoolConst;
import fire.pb.skill.BuffUnit;
import fire.pb.skill.Module;
import fire.pb.skill.Result;
import fire.pb.skill.SkillAgent;
import fire.pb.skill.SkillRole;
import fire.pb.skill.SubSkillConfig;
import fire.pb.skill.fight.FightSkillConfig;
import fire.pb.skill.liveskill.LiveSkillManager;
import fire.script.AbstractJSEngine;
import fire.script.FightJSEngine;
import fire.script.JavaScript;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import org.apache.log4j.Logger;
import xbean.BattleInfo;
import xbean.Monster;
import xbean.MonsterSkill;
import xbean.PracticeSkill;

public class SkillMonster
extends SkillAgent {
    private static final Logger logger = Logger.getLogger((String)"SKILL");
    private final Monster monsterbean;
    private final long roleid;

    public SkillMonster(Monster monsterbean, long roleid) {
        this.monsterbean = monsterbean;
        this.agentType = monsterbean.getFightnpctype();
        this.roleid = roleid;
    }

    @Override
    public boolean hasEffectSkill(int skillId) {
        return this.getLevel(skillId) > 0;
    }

    @Override
    public boolean hasSkill(int skillId) {
        return this.getLevel(skillId) > 0;
    }

    @Override
    public boolean hasAllSkills(int ... skillIds) {
        for (int skillId : skillIds) {
            if (this.hasSkill(skillId)) continue;
            return false;
        }
        return true;
    }

    @Override
    public boolean hasAnySkill(int ... skillIds) {
        for (int skillId : skillIds) {
            if (!this.hasSkill(skillId)) continue;
            return true;
        }
        return false;
    }

    @Override
    public int getLevel(int skillId) {
        for (MonsterSkill skill : this.monsterbean.getSkills()) {
            if (skill.getId() != skillId) continue;
            return skill.getSkilllevel();
        }
        if (this.roleid != 0L) {
            SkillRole skillrole = new SkillRole(this.roleid, true);
            int skillType = skillId / 100000;
            if (skillType == 9) {
                int id = LiveSkillManager.getInstance().GetPracticePassivenessSkillLevelBattleSkill(skillId);
                PracticeSkill skill = skillrole.getPracticeSkill(id);
                if (skill != null) {
                    return skill.getLevel();
                }
                return 0;
            }
        }
        return 0;
    }

    @Override
    public List<Integer> getAllBattleSkills() {
        ArrayList<Integer> skillIds = new ArrayList<Integer>();
        for (MonsterSkill skill : this.monsterbean.getSkills()) {
            skillIds.add(skill.getId());
        }
        if (this.monsterbean.getFightnpctype() == 3 && this.roleid != 0L) {
            SkillRole skillrole = new SkillRole(this.roleid, true);
            skillIds.addAll(LiveSkillManager.getInstance().GetAllPracticeSkillBattleSkill(skillrole, 2));
        }
        return skillIds;
    }

    public boolean addSkill(int skillId) {
        return true;
    }

    public Monster getMonsterbean() {
        return this.monsterbean;
    }

    public Result addPetSkillBuffsWhileOnline(BattleInfo battle) {
        Result result = new Result(true);
        FightJSEngine fightJSEngine = null;
        boolean binitJsEngine = false;
        BuffMonsterImpl buffpet = new BuffMonsterImpl(this.monsterbean);
        for (int skillId : this.getAllBattleSkills()) {
            FightSkillConfig sconf = Module.getInstance().getFightSkillConfig(skillId);
            if (sconf == null) {
                Module.logger.error((Object)("怪物 " + this.monsterbean.getMonsterid() + " 的FightSkillConfig为空，技能ID = " + skillId), (Throwable)new NullPointerException());
                continue;
            }
            if (sconf.isActiveSkill() || sconf.isUseInBattle() || !this.hasEffectSkill(skillId)) continue;
            for (SubSkillConfig subskill : sconf.getSubSkills()) {
                for (BuffUnit buffarg : subskill.getBuffUnits()) {
                    if (buffarg == null || buffarg.buffIndex / 10000 == 51) continue;
                    ConstantlyBuff buff = fire.pb.buff.Module.getInstance().createConstantlyBuff(buffarg.buffIndex);
                    if (!binitJsEngine) {
                        fightJSEngine = battle == null ? new FightJSEngine() : battle.getEngine();
                        binitJsEngine = true;
                    }
                    if (fightJSEngine != null) {
                        fightJSEngine.setSkillLevel(this.getLevel(skillId));
                        fightJSEngine.setGrade(this.monsterbean.getLevel());
                    }
                    for (Map.Entry<Integer, JavaScript> entry : buffarg.effectJavascriptMap.entrySet()) {
                        float addvalue = entry.getValue().eval((AbstractJSEngine)fightJSEngine, null, null).floatValue();
                        if (addvalue == 0.0f) continue;
                        buff.getEffects().put(entry.getKey(), Float.valueOf(addvalue));
                    }
                    result.updateResult(buffpet.addCBuff(buff));
                }
            }
        }
        return result;
    }

    public Result addPetSkillBuffWhileBattle(BattleInfo battle, Fighter ofighter) {
        battle.getEngine().setGrade(this.monsterbean.getLevel());
        BuffMonsterImpl buffpet = new BuffMonsterImpl(this.monsterbean);
        Result result = new Result(true);
        boolean bregfighter = false;
        for (int skillId : this.getAllBattleSkills()) {
            FightSkillConfig sconf = Module.getInstance().getFightSkillConfig(skillId);
            if (sconf == null) {
                if (!logger.isDebugEnabled()) continue;
                logger.debug((Object)("怪物 " + this.monsterbean.getMonsterid() + " FightSkillConfig为空，技能ID = " + skillId), (Throwable)new NullPointerException());
                continue;
            }
            if (sconf.isActiveSkill() || sconf.getType() != 10 || sconf.getSubSkills() == null || sconf.getSubSkills()[0] == null || sconf.getSubSkills()[0].getBuffUnits()[0] == null || !this.hasEffectSkill(skillId)) continue;
            if (!bregfighter) {
                battle.getEngine().setOpFighter(ofighter, sconf.getUsedAttrTypea());
                bregfighter = true;
            }
            battle.getEngine().setSkillLevel(this.getLevel(skillId));
            for (SubSkillConfig subskill : sconf.getSubSkills()) {
                for (BuffUnit buffarg : subskill.getBuffUnits()) {
                    ConstantlyBuff buff;
                    if (buffarg == null || (buff = fire.pb.buff.Module.getInstance().createConstantlyBuff(buffarg.buffIndex)) == null) continue;
                    int nround = buffarg.roundJavascript.eval((AbstractJSEngine)battle.getEngine(), ofighter, null).intValue();
                    if (nround != 0) {
                        buff.setRound(nround);
                    }
                    for (Map.Entry<Integer, JavaScript> entry : buffarg.effectJavascriptMap.entrySet()) {
                        buff.getEffects().put(entry.getKey(), Float.valueOf(entry.getValue().eval((AbstractJSEngine)battle.getEngine(), ofighter, null).floatValue()));
                    }
                    result.updateResult(buffpet.addCBuff(buff));
                }
            }
        }
        if (this.monsterbean.getSchool() == SchoolConst.HUNTER) {
            ConstantlyBuff buff = fire.pb.buff.Module.getInstance().createConstantlyBuff(503007);
            buff.setRound(-1);
            result.updateResult(buffpet.addCBuff(buff));
        }
        return result;
    }

    @Override
    public Result addSkillBuffWhileBattle(BattleInfo battle, Fighter ofighter) {
        return this.addPetSkillBuffWhileBattle(battle, ofighter);
    }

    @Override
    public Result addSkillBuffWhileOnline(BattleInfo battle) {
        return this.addPetSkillBuffsWhileOnline(battle);
    }
}

